<?php

namespace HadonaCloaker\Controller;

use HadonaCloaker\Controller\HccDatabase;

class HccScripts
{  
  public function init()
  {
    add_action('admin_enqueue_scripts', [$this, 'loader_admin']);
    add_action('admin_enqueue_scripts', [$this, 'admin_styles_scripts']);
  }

  public function loader_admin()
  {
    wp_enqueue_style('hcc-style-loader', HCC_URI . 'assets/loader.css', array(), HCC_VER);
  }

  public function admin_styles_scripts() {
    if (isset($_GET['page']) && $_GET['page'] === 'hadona-cloaker-client') {
      $this->hcc_style_scripts();
    }
  }

  public function hcc_style_scripts()
  {
    $user = $this->show_user_info();

    wp_enqueue_style('hcc-style', HCC_URI . 'assets/dist/' . 'hcc-page.css', array(), HCC_VER);
    wp_enqueue_script('hcc-scripts', HCC_URI . 'assets/dist/' . 'hcc-page.js', array(), HCC_VER, true);
    wp_localize_script('hcc-scripts', 'hccData', array(
      'user' => isset($user) ? $user : '',
      'is_expired' => isset($user) ? $this->is_expired($user->expired_date) : 'available',
      'url' => get_site_url(),
      'nonce' => wp_create_nonce('hadona-cloaker'),
      'ajax_url' => admin_url('admin-ajax.php'),
      'admin_url' => admin_url(),
      'cloaker_admin' => HCA_URL
    ));
  }

  public function is_expired($date)
  {
    date_default_timezone_set('Asia/Jakarta');
    $current_time = date('Y-m-d');
    return $date < $current_time ? 'expired' : 'available';
  }

  public function show_user_info()
  {
    $db_class = new HccDatabase();
    $user_info = $db_class->get_user_info();
    return $user_info;
  }
}
