<?php
/**
* Plugin Name: Hadona Cloaker Client
* Plugin URI: https://hadona.id/
* Description: This plugin will hide your page content from unwanted user.
* Version: 1.2.0
* Author: Hadona
* License: MIT
* Icon: assets/icon.png
*/

define('HCC_VER', '1.2.0');
define('HCC_URI', plugin_dir_url(__FILE__));
define('HCC_DIR', dirname(__FILE__));
define('HCA_URL', 'https://hadona.id/');


require(HCC_DIR . '/controller/hcc-database.php');
require(HCC_DIR . '/controller/hcc-rest-api.php');
require(HCC_DIR . '/controller/hcc-scripts.php');
require(HCC_DIR . '/controller/hcc-shortcode.php');

use HadonaCloaker\Controller\HccDatabase;
use HadonaCloaker\Controller\HccRestApi;
use HadonaCloaker\Controller\HccScripts;
use HadonaCloaker\Controller\HccShortcode;

class HadonaCloaker
{
	public function init()
	{
		register_activation_hook(__FILE__, [$this, 'install_plugin']);
		add_action('plugins_loaded', [$this, 'update_plugin']);
    add_action('admin_menu', [$this, 'hcc_actions']);

		$rest_api_init = new HccRestApi();
		$rest_api_init->init();

		$enqueue_scripts = new HccScripts();
		$enqueue_scripts->init();

		$shortcode = new HccShortcode();
		$shortcode->init();
	}

	public function install_plugin()
	{
		$db = new HccDatabase();
		$db->create_tables();
	}

	public function update_plugin()
	{
		if (get_site_option('hcc_ver') !== HCC_VER) {
			$this->install_plugin();
		}
	}

	public function hcc_actions()
  {
    $plugin_dir_url = plugins_url('', __FILE__);
    $icon_url = $plugin_dir_url . '/assets/icon.png';

    add_menu_page("Hadona Cloaker", "Hadona Cloaker", "manage_options", "hadona-cloaker-client", [$this, 'hcc_menu'], $icon_url);
  }

  function hcc_menu()
  {
    include(HCC_DIR . '/views/index.php');
  }
}

$cloaker_admin = new HadonaCloaker();
$cloaker_admin->init();